Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.value
Class Int64Value

    java.lang.Object
      net.sf.saxon.value.Value
          net.sf.saxon.value.AtomicValue
              net.sf.saxon.value.NumericValue
                  net.sf.saxon.value.IntegerValue
                      net.sf.saxon.value.Int64Value

All Implemented Interfaces:
  Serializable, Comparable, SequenceIterable, Item, ValueRepresentation

    public final class Int64Value

extends IntegerValue

An integer value: note this is a subtype of decimal in XML Schema, not a primitive type. This class supports integer values in the range permitted by a Java "long", and also supports the built-in subtypes of xs:integer.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.value.IntegerValue
`MAX_LONG, MIN_LONG, MINUS_ONE, PLUS_ONE, SMALL_INTEGERS, ZERO`

Fields inherited from class net.sf.saxon.value.Value
`EMPTY_CLASS_ARRAY, INDETERMINATE_ORDERING`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`Int64Value(long value)` Constructor supplying a long
`Int64Value(long val, AtomicType type, boolean check)` Constructor for a subtype, supplying a long and a type label.

Method Summary
`NumericValue` | `arithmetic(int operator, NumericValue other, XPathContext context)` Evaluate a binary arithmetic operator.
`BigInteger` | `asBigInteger()` Get the value as a BigInteger
`NumericValue` | `ceiling()` Implement the XPath ceiling() function
`boolean` | `checkRange(AtomicType type)` This class allows subtypes of xs:integer to be held, as well as xs:integer values.
`int` | `compareTo(long other)` Compare the value to a long
`int` | `compareTo(Object other)` Compare the value to another numeric value
`AtomicValue` | `convertPrimitive(BuiltInAtomicType requiredType, boolean validate, XPathContext context)` Convert to target data type
`Object` | `convertToJava(Class target, XPathContext context)` Convert to Java object (for passing to external functions)
`ValidationException` | `convertToSubType(AtomicType subtype, boolean validate)` Convert the value to a subtype of xs:integer
`AtomicValue` | `copy(AtomicType typeLabel)` Create a copy of this atomic value, with a different type label
`NumericValue` | `div(IntegerValue other)` Divide by another integer
`boolean` | `effectiveBooleanValue()` Return the effective boolean value of this integer
`NumericValue` | `floor()` Implement the XPath floor() function
`BigDecimal` | `getDecimalValue()` Get the numeric value converted to a decimal
`double` | `getDoubleValue()` Get the numeric value as a double
`float` | `getFloatValue()` Get the numeric value converted to a float
`String` | `getStringValue()` Get the value as a String
`int` | `hashCode()` Get the hashCode.
`IntegerValue` | `idiv(IntegerValue other)` Integer divide by another integer
`long` | `longValue()` Get the value
`static Int64Value` | `makeDerived(long val, AtomicType type)` Factory method to create a derived value, with no checking of the value against the derived type
`static Int64Value` | `makeIntegerValue(long value)` Factory method: allows Int64Value objects to be reused.
`IntegerValue` | `minus(IntegerValue other)` Subtract another integer
`IntegerValue` | `mod(IntegerValue other)` Take modulo another integer
`NumericValue` | `negate()` Negate the value
`IntegerValue` | `plus(IntegerValue other)` Add another integer
`NumericValue` | `round()` Implement the XPath round() function
`NumericValue` | `roundHalfToEven(int scale)` Implement the XPath round-to-half-even() function
`void` | `setSubType(AtomicType type)` This class allows subtypes of xs:integer to be held, as well as xs:integer values.
`double` | `signum()` Determine whether the value is negative, zero, or positive
`static Int64Value` | `signum(long val)` Factory method returning the integer -1, 0, or +1 according as the argument is negative, zero, or positive
`IntegerValue` | `times(IntegerValue other)` Multiply by another integer

Methods inherited from class net.sf.saxon.value.IntegerValue
`checkBigRange, checkRange, getPrimitiveType, getSchemaComparable, isWholeNumber, makeIntegerValue, stringToInteger`

Methods inherited from class net.sf.saxon.value.NumericValue
`equals, getXPathComparable, isInteger, isNaN, parseNumber, promote, toString`

Methods inherited from class net.sf.saxon.value.AtomicValue
`checkPermittedContents, convert, convert, getCardinality, getComponent, getItemType, getLength, getStringValueCS, getTypedValue, getTypeLabel, hasBuiltInType, isMultiValued, itemAt, iterate, process, setTypeLabel`

Methods inherited from class net.sf.saxon.value.Value
`asItem, asItem, asIterator, asValue, convert, convertJavaObjectToXPath, fromItem, getCanonicalLexicalRepresentation, getIterator, iterate, makeQNameValue, reduce, stringToNumber`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### Int64Value

    public Int64Value(long value)

  Constructor supplying a long

  Parameters:
    `value` - the value of the IntegerValue

### Int64Value

    public Int64Value(long val,
                      AtomicType type,
                      boolean check)
               throws DynamicError

  Constructor for a subtype, supplying a long and a type label.

  Parameters:
    `val` - The supplied value, as an integer
    `type` - the required item type, a subtype of xs:integer
    `check` - Set to true if the method is required to check that the value is in range; false if the caller can guarantee that the value has already been checked.
  Throws:
    `DynamicError` - if the supplied value is out of range for the target type

Method Detail

### makeIntegerValue

    public static Int64Value makeIntegerValue(long value)

  Factory method: allows Int64Value objects to be reused. Note that a value obtained using this method must not be modified to set a type label, because the value is in general shared.

### makeDerived

    public static Int64Value makeDerived(long val,
                                         AtomicType type)

  Factory method to create a derived value, with no checking of the value against the derived type

### signum

    public static Int64Value signum(long val)

  Factory method returning the integer -1, 0, or +1 according as the argument is negative, zero, or positive

### copy

    public AtomicValue copy(AtomicType typeLabel)

  Create a copy of this atomic value, with a different type label

  Specified by:
    `copy` in class `AtomicValue`
  Parameters:
    `typeLabel` - the type label of the new copy. The caller is responsible for checking that the value actually conforms to this type.

### convertToSubType

    public ValidationException convertToSubType(AtomicType subtype,
                                                boolean validate)

  Convert the value to a subtype of xs:integer

  Specified by:
    `convertToSubType` in class `IntegerValue`
  Parameters:
    `subtype` - the target subtype
    `validate` - true if validation is required; false if the caller already knows that the value is valid
  Returns:
    null if the conversion succeeds; a ValidationException describing the failure if it fails. Note that the exception is returned, not thrown.

### setSubType

    public void setSubType(AtomicType type)

  This class allows subtypes of xs:integer to be held, as well as xs:integer values. This method sets the required type label. It is the caller's responsibility to check that the value is within range.

### checkRange

    public boolean checkRange(AtomicType type)

  This class allows subtypes of xs:integer to be held, as well as xs:integer values. This method checks that the value is within range, and also sets the type label.

  Parameters:
    `type` - the subtype of integer required
  Returns:
    true if successful, false if value is out of range for the subtype

### hashCode

    public int hashCode()

  Get the hashCode. This must conform to the rules for other NumericValue hashcodes

  Specified by:
    `hashCode` in class `NumericValue`
  Returns:
    the hash code of the numeric value
  See Also:
    `NumericValue.hashCode()`

### longValue

    public long longValue()

  Get the value

  Overrides:
    `longValue` in class `NumericValue`
  Returns:
    the value of the xs:integer, as a Java long

### effectiveBooleanValue

    public boolean effectiveBooleanValue()

  Return the effective boolean value of this integer

  Overrides:
    `effectiveBooleanValue` in class `AtomicValue`
  Returns:
    false if the integer is zero, otherwise true

### compareTo

    public int compareTo(Object other)

  Compare the value to another numeric value

  Specified by:
    `compareTo` in interface `Comparable`
  Overrides:
    `compareTo` in class `NumericValue`
  Parameters:
    `other` - the numeric value to be compared to this value
  Returns:
    -1 if this value is less than the other, 0 if they are equal, +1 if this value is greater

### compareTo

    public int compareTo(long other)

  Compare the value to a long

  Specified by:
    `compareTo` in class `NumericValue`
  Parameters:
    `other` - the value to be compared with
  Returns:
    -1 if this is less, 0 if this is equal, +1 if this is greater or if this is NaN

### convertPrimitive

    public AtomicValue convertPrimitive(BuiltInAtomicType requiredType,
                                        boolean validate,
                                        XPathContext context)

  Convert to target data type

  Specified by:
    `convertPrimitive` in class `AtomicValue`
  Parameters:
    `requiredType` - an integer identifying the required atomic type
    `context` -
    `validate` - true if validation is required. If set to false, the caller guarantees that the value is valid for the target data type, and that further validation is therefore not required. Note that a validation failure may be reported even if validation was not requested.
  Returns:
    an AtomicValue, a value of the required type

### getStringValue

    public String getStringValue()

  Get the value as a String

  Specified by:
    `getStringValue` in interface `Item`
  Specified by:
    `getStringValue` in interface `ValueRepresentation`
  Specified by:
    `getStringValue` in class `AtomicValue`
  Returns:
    a String representation of the value
  See Also:
    `Item.getStringValueCS()`

### getDoubleValue

    public double getDoubleValue()

  Get the numeric value as a double

  Overrides:
    `getDoubleValue` in class `NumericValue`
  Returns:
    A double representing this numeric value; NaN if it cannot be converted

### getFloatValue

    public float getFloatValue()

  Get the numeric value converted to a float

  Overrides:
    `getFloatValue` in class `NumericValue`
  Returns:
    a float representing this numeric value; NaN if it cannot be converted

### getDecimalValue

    public BigDecimal getDecimalValue()

  Get the numeric value converted to a decimal

  Overrides:
    `getDecimalValue` in class `NumericValue`
  Returns:
    a decimal representing this numeric value;

### negate

    public NumericValue negate()

  Negate the value

  Specified by:
    `negate` in class `NumericValue`
  Returns:
    the result of inverting the sign of the value

### floor

    public NumericValue floor()

  Implement the XPath floor() function

  Specified by:
    `floor` in class `NumericValue`
  Returns:
    the integer value, unchanged

### ceiling

    public NumericValue ceiling()

  Implement the XPath ceiling() function

  Specified by:
    `ceiling` in class `NumericValue`
  Returns:
    the integer value, unchanged

### round

    public NumericValue round()

  Implement the XPath round() function

  Specified by:
    `round` in class `NumericValue`
  Returns:
    the integer value, unchanged

### roundHalfToEven

    public NumericValue roundHalfToEven(int scale)

  Implement the XPath round-to-half-even() function

  Specified by:
    `roundHalfToEven` in class `NumericValue`
  Parameters:
    `scale` - number of digits required after the decimal point; the value -2 (for example) means round to a multiple of 100
  Returns:
    if the scale is >=0, return this value unchanged. Otherwise round it to a multiple of 10**-scale

### signum

    public double signum()

  Determine whether the value is negative, zero, or positive

  Specified by:
    `signum` in class `NumericValue`
  Returns:
    -1 if negative, 0 if zero, +1 if positive, NaN if NaN

### arithmetic

    public NumericValue arithmetic(int operator,
                                   NumericValue other,
                                   XPathContext context)
                            throws XPathException

  Evaluate a binary arithmetic operator.

  Specified by:
    `arithmetic` in class `NumericValue`
  Parameters:
    `operator` - the operator to be applied, identified by a constant in the Tokenizer class
    `other` - the other operand of the arithmetic expression
  Returns:
    the result of performing the arithmetic operation
  Throws:
    `XPathException` - if an arithmetic failure occurs, e.g. divide by zero
  See Also:
    `Tokenizer`

### plus

    public IntegerValue plus(IntegerValue other)

  Add another integer

  Specified by:
    `plus` in class `IntegerValue`

### minus

    public IntegerValue minus(IntegerValue other)

  Subtract another integer

  Specified by:
    `minus` in class `IntegerValue`

### times

    public IntegerValue times(IntegerValue other)

  Multiply by another integer

  Specified by:
    `times` in class `IntegerValue`

### div

    public NumericValue div(IntegerValue other)
                     throws XPathException

  Divide by another integer

  Specified by:
    `div` in class `IntegerValue`
  Throws:
    `XPathException` - if the other integer is zero

### mod

    public IntegerValue mod(IntegerValue other)
                     throws XPathException

  Take modulo another integer

  Specified by:
    `mod` in class `IntegerValue`
  Throws:
    `XPathException` - if the other integer is zero

### idiv

    public IntegerValue idiv(IntegerValue other)
                      throws XPathException

  Integer divide by another integer

  Specified by:
    `idiv` in class `IntegerValue`
  Throws:
    `XPathException` - if the other integer is zero

### asBigInteger

    public BigInteger asBigInteger()

  Get the value as a BigInteger

  Specified by:
    `asBigInteger` in class `IntegerValue`

### convertToJava

    public Object convertToJava(Class target,
                                XPathContext context)
                         throws XPathException

  Convert to Java object (for passing to external functions)

  Overrides:
    `convertToJava` in class `Value`
  Parameters:
    `target` - The Java class to which conversion is required
  Returns:
    the Java object that results from the conversion; always an instance of the target class
  Throws:
    `XPathException` - if conversion is not possible, or fails

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.